<script context="module" lang="ts">
	import { init as InitFirebase } from '@/lib/firebase'

	export async function load({}) {
		await InitFirebase()
		return {
			props: {}
		}
	}
</script>

<script lang="ts">
	import '@/styles'
	import { goto } from '$app/navigation'
	import { onMount } from 'svelte'
	import { page } from '$app/stores'
	import { getAuth } from 'firebase/auth'
	import AuthStore from '@/stores/auth'

	onMount(async () => {
		getAuth().onAuthStateChanged((user) => {
			AuthStore.set({
				isLoggedIn: user !== null,
				user
			})
		})
		AuthStore.subscribe(async ({ isLoggedIn }) => {
			if (!isLoggedIn) {
				await goto('/')
			} else if ($page.path == '/') {
				await goto('/onboard')
			}
		})
	})

	function logout() {
		getAuth().signOut()
	}
</script>

<main class="app">
	<div class="flex-1 overflow-y-scroll">
		<slot />
	</div>
	{#if $AuthStore.isLoggedIn}
		<div class="flex border-t-1 p-4 items-center">
			<svg
				class="h-6 text-gray-400 w-6 class block"
				fill="none"
				viewBox="0 0 24 24"
				stroke="currentColor"
			>
				<path
					stroke-linecap="round"
					stroke-linejoin="round"
					stroke-width="2"
					d="M5.121 17.804A13.937 13.937 0 0112 16c2.5 0 4.847.655 6.879 1.804M15 10a3 3 0 11-6 0 3 3 0 016 0zm6 2a9 9 0 11-18 0 9 9 0 0118 0z"
				/>
			</svg>
			<button on:click={logout} class="ml-auto text-gray-400 block hover:text-gray-500">
				<svg class="h-6 w-6 block" fill="none" viewBox="0 0 24 24" stroke="currentColor">
					<path
						stroke-linecap="round"
						stroke-linejoin="round"
						stroke-width="2"
						d="M17 16l4-4m0 0l-4-4m4 4H7m6 4v1a3 3 0 01-3 3H6a3 3 0 01-3-3V7a3 3 0 013-3h4a3 3 0 013 3v1"
					/>
				</svg>
			</button>
		</div>
	{/if}
</main>

<style>
	:global(body) {
		@apply bg-gray-50;
	}
	.app {
		@apply flex flex-col h-screen mx-auto w-screen justify-center;
	}
</style>
